<!DOCTYPE html>
<html>
<head>
	<title>Arrays</title>
</head>
<body>
	<script type="text/javascript">
		var cars = ['Merc', 'BMW', 'Fiat'];
		console.log(cars, typeof cars);	//prints entire array
		console.log(cars[1]);	//prints element at index 1
		cars.push('Volvo');	//Add a new element to array
		console.log(cars[3]);
		var cars2 = new Array('Nissan', 'Subaru', 'Chevy');
		console.log(cars2, typeof cars2);

		var person = {firstname: 'John', lastname: 'Doe'};
		console.log(person.firstname);
		var mixedArray = [];
		mixedArray[0] = new Date();
		mixedArray[1] = cars;
		mixedArray[mixedArray.length] = function myFunction(){

		};
		console.log(mixedArray.length);
		
		var namedArray = [];
		namedArray['firstName'] = "John";	//not possible in JS

		console.log(Array.isArray(cars2));	//checks whether the variable is an array
		console.log(cars instanceof Array);




		//ARRAY METHODS
		console.log("\n\n==========Array methods==========");
		var fruits = ['Banana', 'Orange', 'Apple', 'Mango'];
		console.log(fruits);
		console.log("\ntoString() method in action " + fruits.toString());
		console.log("join() in action " + fruits.join('|'));

		//push and pop
		fruits.push('Kiwi');
		console.log('\nafter push() fruits = ' + fruits);
		fruits.pop();
		console.log("after pop() fruits = " + fruits);


		//shift and unshift
		//shifting is equivalent to pop but works on 1st element
		fruits.shift();
		console.log("\nafter shift fruits = " + fruits);
		fruits.unshift('Banana');
		console.log("after unshift fruits = " + fruits);

		//Changing elements
		fruits[0] = 'Kiwi';
		console.log("\nfruits after changing first element = " + fruits);
		fruits[fruits.length] = 'Banana';
		console.log('added banana to end ' + fruits);

		//delete : deleting can cause undefined spaces in array
		delete fruits[0];
		console.log("\nafter delete() : " + fruits);

		//splice(index, how_many_items_to_remove, items...)
		fruits = ['Banana', 'Orange', 'Apple', 'Mango'];
		console.log("\n\nbefore splice() to add: " + fruits);
		fruits.splice(2, 0, "Lemon", "Kiwi");
		console.log("after splice to add: " + fruits);
		console.log("before splice() to delete: " + fruits);
		fruits.splice(0,1);
		console.log("after splice to delete: " + fruits);

		//join
		var array1 = ['hello', 'hi'];
		var array2 = ['bye', 'tata'];
		var array3 = ['njan', 'ni'];
		var array = array1.concat(array2, array3);
		console.log(array);

		//slice() : it generates another array
		fruits = ['Banana', 'Orange', 'Apple', 'Mango'];
		var fruits2 = fruits.slice(1);	//slices from index 1 to end
		console.log("fruits2 = " + fruits2);
		var fruits3 = fruits.slice(1,3);
		console.log("fruits3 = " + fruits3);

		//ARRAY SORTING
		console.log("\n\n==========Array SORTING==========");
		console.log("Sorted fruits array  = " + fruits.sort());
		console.log("Reverse Sorted fruits array  = " + fruits.reverse());

		//for numeric arrays we cannot use sort() and reverse()
		var points = [40, 100, 25, 1, 5, 10, 15];
		points.sort(function(a,b){return a - b});
		console.log(points);

		//reverse numeric array
		points = [40, 100, 25, 1, 5, 10, 15];
		points.sort(function(a,b){return b - a});
		console.log(points);

		//shuffling array elements
		points.sort(function(a,b){return 0.5 - Math.random()});
		console.log(points);

		//sort an array of objects
		var cars3 = [
			{name: 'Volvo', year: 2019},
			{name: 'Merc', year: 2015},
			{name: 'BMW', year: 2017}
		];
		console.log(cars3);
		cars3.sort(function(a, b){return a.year - b.year});
		console.log(cars3);

		//sort based on string parameters
		cars3.sort(function(a,b){
			var x = a.name.toLowerCase();
			var y = b.name.toLowerCase();
			if(x < y){
				return -1;
			}
			if(x > y){
				return 1;
			}
			return 0;
		});
		console.table(cars3);
	</script>
</body>
</html>